// Veronika Usova, Erg, 2007.
// http://www.workplace.lescorsaires.be/liluli/
// realise avec Processing 123 Beta


// declare 2 tableaux d'objets pelouse et bouquet
Herbe[] pelouse; 
Fleur[] bouquet; 

// declare nombre de brins d'herbe
int nbrBrins=85;
// declare nombre maximal de fleurs (taille de tableau) 
int nbrFleursMax=200;
// declare nombre de fleur deja creee
int nbrFleurs=0;

int temps=0; // temps de fonctionnement du programme (pour viter les doublures d'objet)
int tempsAuDernierObjetFleur=0; // a quel moment on a cree le dernier objet fleur (reference au temps)
int tempsEntreChaqueCreationDeFleur=10; // en seconde, nombre d'images/seconde

void setup() 
{
  // intialisation de tableaux
  bouquet=new Fleur[nbrFleursMax];
  pelouse=new Herbe[nbrBrins];
    
  // creation des objets Herbe de 0  nbrBrins
  for(int i=0;i<nbrBrins;i++){
    pelouse[i]=new Herbe((i-15)*10,1.5,280);
  }
  // taille de la fenetre
  size(300, 300);
  
  // nombre d'images/seconde
  frameRate(30);
}

void draw() {
 // definit la couleur de fond
  background(204,218,255);
 temps++; // on augmente le temps
 // quand on clique sur la souris:  
  if(mousePressed){
    if(nbrFleurs<nbrFleursMax){ // si le nombre de Fleurs deja creees est inferieur au nombre de Fleurs Maximum, alors, on peut ajouter un objet Fleur dans le bouquet 
      
      // pour viter les creations multiples, on attend un instant "tempsEntreChaqueCreationDeFleur"
      if(temps>tempsAuDernierObjetFleur+tempsEntreChaqueCreationDeFleur){
      bouquet[nbrFleurs]= new Fleur(mouseX, 1, mouseY, 15); // un objet Fleur est construit  l'endroit ou on clique
      tempsAuDernierObjetFleur=temps;
      nbrFleurs++; // mise  jour du nombre de fleurs
      }
    }
  }
  for(int i=0;i<nbrBrins;i++){ // pour chaque objet herbe du tableau pelouse
    pelouse[i].update();      // on actualise par la methode update
  }
  for(int i=0;i<nbrFleurs;i++){ // pour chaque objet Fleur cree du tableau bouquet
    bouquet[i].update();       // on actualise par la methode update 
  }

} 


 // Classe Fleur
class Fleur { 
  float xHaut,        // position sur l'axe x du point plus haute de la tige de la fleur 
        xBas,         // position sur l'axe x du point plus basse de la tige de la fleur 
        speed,        // la vitesse de deplacement  
        centreFleur,  // le diamentre du centre de la fleur 
        hauteur;      // hauteur de la fleur
    int VERS_LA_DROITE=1,VERS_LA_GAUCHE=-1; // dfinition des sens possibles
    
    int sens=VERS_LA_DROITE;       // sens de deplacement: vers la droite ou vers la gauche, (on commence par la droite)
    
  Fleur (float x, float _speed, float _hauteur, float _centreFleur){ 
   // initialisation des valeurs de l'objet cree 
    xBas = x;
    xHaut = x;
    speed = _speed; 
    hauteur= _hauteur;  
    centreFleur=_centreFleur;
    } 

 // methode update de la classe Fleur (mise  jour du dessin)
  void update() { 
    
    float petale,               // grandeur du petale
          paddingPetale=5,      // espace entre petales
          deplacemlentFleur=30; // deplacement de la fleur (fin de course)
        
    if(xHaut>=(xBas+deplacemlentFleur)) sens=VERS_LA_GAUCHE; // si la position haute de la fleur est arrivee en fin de course droite, on change de sens (vers la gauche)
                                                            // xBas est aussi la position de reference de la fleur
                                                
    if(xHaut<=(xBas-deplacemlentFleur)) sens=VERS_LA_DROITE; // si la position haute de la fleur est arrivee en fin de course gauche, on change de sens (vers la droite) 
    
    if(sens==VERS_LA_DROITE) xHaut += speed;  // si le sens est "vers la droite", la position de la fleur augmente de "speed"
    if(sens==VERS_LA_GAUCHE) xHaut -= speed;  // si le sens est "vers la gauche", la position de la fleur diminue de "speed"
    
    stroke(#00ff00);                          // couleur du trait 
    line( xBas, height, xHaut, hauteur);      // dessine la tige  
    stroke(#00aa00);                          // couleur du trait 
    line( xBas+1, height, xHaut+1, hauteur);  // double la tige
     
    petale=centreFleur*2;
    
    fill(#ffffff); // remplir la prochaine forme de cette couleur
    stroke(#000000); // dessine le prochain trait de cette couleur
    // dessin des 4 petales (4 triangles)
    triangle(xHaut, hauteur, xHaut-petale, hauteur+paddingPetale, xHaut-paddingPetale, hauteur+petale);
    triangle(xHaut, hauteur, xHaut+paddingPetale, hauteur+petale, xHaut+petale, hauteur+paddingPetale);
    triangle(xHaut, hauteur, xHaut-paddingPetale, hauteur-petale, xHaut-petale, hauteur-paddingPetale);
    triangle(xHaut, hauteur, xHaut+petale, hauteur-paddingPetale, xHaut+paddingPetale, hauteur-petale);
    
    fill(246,255,103); // remplir la prochaine forme de cette couleur
    noStroke(); // ne dessine plus de trait colore
    ellipse( xHaut, hauteur, centreFleur, centreFleur); // dessine une elipse
    noFill(); // plus de remplissage
    
  } // fin de Update 

} // fin de la classe Fleur
  
  
 // Classe Herbe (dessin d'un brin d'herbe)
 class Herbe { 
  float xHaut,   // position x du point bas du brun d'herbe 
        xBas,    // position  x du point haut du brun d'herbe
        speed,   // la vitesse de deplacement (grandeur du pas) 
        hauteur; // hauteur du brin d'herbe  
        
    int VERS_LA_DROITE=1,VERS_LA_GAUCHE=-1; // dfinition des sens possibles 
    int sens=1;  // sens du deplacement du brin d'herbe(on commence par la droite)
    
  Herbe (float x, float _speed, float _hauteur){  
    // initialisation des valeurs de l'objet cree
    xBas = x; 
    xHaut = x;
    speed = _speed;
    hauteur=_hauteur;
    } 

 
  void update() { //methode update de la classe Herbe (mise  jour du dessin)
   
    if(xHaut>=(xBas+30))sens=VERS_LA_GAUCHE;  // si la position haute du brin d'herbe est arrivee en fin de course droite, on change de sens (vers la gauche)
                                              // xBas est aussi la position de reference du brin d'herbe
    if(xHaut<=(xBas-30))sens=VERS_LA_DROITE;  // si la position haute du brin d'herbe est arrivee en fin de course gauche, on change de sens (vers la droite)
    
    if(sens==VERS_LA_DROITE) xHaut += speed;  // si le sens est "vers la droite", la position du brun d'herbe augmente de "speed"
    if(sens==VERS_LA_GAUCHE) xHaut -= speed;  // si le sens est "vers la gauche", la position du brun d'herbe diminue de "speed"     
    stroke(70,200,42);                        // couleur du prochain trait
    line( xBas, height, xHaut, hauteur);      // dessine un trait (brin d'herbe)
    line( xBas+1, height, xHaut+1, hauteur);  // double le trait du brin d'herbe   
  
  }// fin de la methode Update 

}// fin de la classe Herbe

